ZUpload: 
zzz_FS   = arg(1);  /* Diese Datei (inkl. Header) wird ...     */
FileSpec = arg(2);  /* ... unter diesem Std-Namen hochgeladen  */
QDoZip   = ( arg(3)<>"NOZIP" );

/* "EF_Act_HTTPDir" = arg(3);
   "EF_Act_RPath"   = arg(4);			*/

BakDir = directory();

Call XSay "Generating upload-file...."FileSpec;

if( \QDoZip ) then do
   LocalFile  = zzz_FS;
   SIGNAL AROUND1;  /* skip gz-Verarbeitung 	*/
end;

nok = SysFileDelete(FileSpec);
if nok = 0 | nok = 2 then NOP;
else;do
   Err = "Unexpected error ('"nok"')";
   if nok =  5 then Err = "Access denied";
   if nok = 32 then Err = "Sharing violation";
   Call XSay "Error deleting upload-file '"FileSpec"': "Err"!";
   ok = directory(BakDir);
   RETURN 0;
end;

Content = CharIn(zzz_FS, 1, Chars(zzz_FS) );    /* inkl. Header-Record (nur bei Art) */

ok = LineOut(FileSpec, Content );

ok = stream(FileSpec, "c","close");
ok = stream(zzz_FS,   "c","close");

/* ---------------------------  */
/* Step-2: Packen (gz-Format):  */
/* ---------------------------  */

if \LoadDLL('RXGZLIB', 'rxgzLoadFuncs') then do  /* Lib zum Erzeugen eines gzip-Formates  */
   Call XSay "RXGZLIB not found - transferring data uncompressed";
   LocalFile  = FileSpec;
   FileType = ".uc";  /* (uncompressed)  */
end;
else;do
   Call XSay "Making gz-file....";

   FileType = ".gz";

   gzipFile = FileSpec||FileType;

   Option = "9";   /* Max. compression-rate                    */
   rc = rxgzDeflateFile(FileSpec, gzipFile, Option);    /* 0=ok */
   ok = SysSleep(1);
   Call XSay "Making gz-file....done! ("rc")",,"REPL";

   Call XSay "Uploading "gzipFile"....";
   LocalFile  = gzipFile;
end;

AROUND1:

/* ---------------------------  */
/* Step-3: Uploading xx_File:   */
/* ---------------------------  */

/* ZFTP_Logon() ist schon ausserhalb passiert, aber FtpLogoff() hier unten	*/

/* ---------------------------  */
/* Nun Datei hochladen:         */
/* ---------------------------- */
RemoteFile = filespec("name",LocalFile);

Mode = "Binary";

/* ------------------------------------------------             */
/* Zuerst Ziel-Pfad auf dem Remote Server bestimmen             */
/* ------------------------------------------------             */

/* ++ das funzt nur, solange nur ein Dir existiert		*/

Remote_SubDir = VRGet("EF_Act_HTTPDir","Value") || VRGet("EF_Act_RPath","Value");

Remote_SubDir = strip(Remote_SubDir,"T","/") || "/";  /* immer mit / enden	*/
Remote_SubDir = "/" || strip(Remote_SubDir,"L","/");  /* immer mit / beginnen	*/

Call XSay "Einloggen in Remote_SubDir="Remote_SubDir"!";

if(0) then ok = FtpChDir("/");ok = ZFTPAfter("Initial ChDir to root!",ok);

ok = FtpChDir(Remote_SubDir);ok = ZFTPAfter("Initial ChDir",Remote_SubDir);

Call XSay "Uploading '"LocalFile"' to '"Remote_SubDir || RemoteFile"'...";

ok = SysFileTree(LocalFile,"files.","F");
if files.0 <> 1 then do
   Call Xsay "Sysfail - '"LocalFile"' not found!";
   RETURN -1;
end;

rc = FtpPut(LocalFile,RemoteFile,Mode);nok=ZFTPAfter("Put",RemoteFile);
if nok <> 0 then do
   Call Xsay "rc="rc", PUT fr Datei '"LocalFile"' nach '"RemoteFile"' nicht erfolgreich ("ZFTPErr(FTPERRNO)")";
   nok = 1;
end;
else;do
   if ( FileType = "PHP" ) then do 	/* kommt hier eigentlich nie (?) vor ... */
   
      QuoteString = "site chmod 777 "RemoteFile;
      Call XSay "Setting attribute to executable...("QuoteString")";
      rc = FtpQuote(QuoteString);nok=ZFTPAfter("quote site chmod",RemoteFile);
      if nok <> 0 then do
         Call Xsay "rc="rc", QUOTE(Chmod) failed for file "RemoteFile" ("ZFTPErr(FTPERRNO)")";
         nok = 1;
      end;
      else;do
        /* File erfolgreich uploaded:                              */
        Call Xsay "Upload '"LocalFile"' to '"RemoteFile"' successful";
      end;
   end;
end;
/* ---------------------------  */

say "NOK="NOK"!";
return \NOK RemoteFile;		/* 1: OK	*/

/* ---------------------------	*/
XSay: Procedure;
What = strip(arg(1));
Text = strip(arg(2));
if What = "" ,
 | What = "TOF" ,
 | What = "BOF" then RETURN "";

say date()"-"substr(time(),1,8)"=>"Text What;
return Text What;

/* --------------------	*/
ZFTPAfter: procedure Expose FTPErrno;
What = arg(1);
Parm = arg(2);

/* -------------------------------------------------------------------  */
/* ZFTPAfter: Allgemeine ftp-errno-Auswertung:                          */
/* -------------------------------------------------------------------  */

if FTPErrno <> 0 then do
   Call Xsay "Error nach "What"/"Parm": "ZFTPErr(FTPErrno)"!";
end;
else;
   Call Xsay "Successful completion of "What"/"Parm"!";

return FTPErrno;

/* -------------------------            */
/* ZFTPErr:                             */
/* -------------------------            */
ZFTPErr: procedure
Errno = arg(1);

Select
  WHEN      Errno = "FTPSERVICE"   THEN do;Return "unknown service";end;
  WHEN      Errno = "FTPHOST"      THEN do;Return "unknown host";end;
  WHEN      Errno = "FTPSOCKET"    THEN do;Return "unable to obtain socket";end;
  WHEN      Errno = "FTPCONNECT"   THEN do;Return "unable to connect to server";end;
  WHEN      Errno = "FTPLOGIN"     THEN do;Return "login failed";end;
  WHEN      Errno = "FTPABORT"     THEN do;Return "transfer aborted";end;
  WHEN      Errno = "FTPLOCALFILE" THEN do;Return "problem openning local file";end;
  WHEN      Errno = "FTPDATACONN"  THEN do;Return "problem initializing data connection";end;
  WHEN      Errno = "FTPCOMMAND"   THEN do;Return "command failed (prpbly file not found)";end;
  WHEN      Errno = "FTPPROXYTHIRD"THEN do;Return "proxy server does not support third party transfers";end;
  WHEN      Errno = "FTPNOPRIMARY" THEN do;Return "no primary connection for proxy transfer";end;
  OTHERWISE
      do;Return "<unknown FTP-returncode> "Errno;end;

return 0;
